unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, xmldom, XMLIntf, QComCtrls, xercesxmldom, XMLDoc,
  QImgList, QExtCtrls;

type
  TForm1 = class(TForm)
    XMLDocument1: TXMLDocument;
    TreeView1: TTreeView;
    GroupBox1: TGroupBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    OpenDialog1: TOpenDialog;
    ImageList1: TImageList;
    Button1: TButton;
    Label13: TLabel;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
   iX: Integer;
   iR: Integer;
   iE: Integer;
   iT: Integer;
   iA: Integer;
   iV: Integer;

   procedure XMLParser( szFileName: String );
   procedure XMLTree( TN: TTreeNode; XN: IXMLNode; iIndex: Integer );
    
  public
    
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   iX:=0;
   iR:=0;
   iE:=0;
   iT:=0;
   iA:=0;
   iV:=0;
   Label7.Caption:=IntToStr(iX);
   Label8.Caption:=IntToStr(iR);
   Label9.Caption:=IntToStr(iE);
   Label10.Caption:=IntToStr(iT);
   Label11.Caption:=IntToStr(iA);
   Label12.Caption:=IntToStr(iV);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
   if OpenDialog1.Execute then
   begin
      if FileExists( OpenDialog1.FileName ) then
      begin
         XMLParser( OpenDialog1.FileName );
      end;
   end;

end;

procedure TForm1.XMLParser(szFileName: String);
var
   TN: TTreeNode;
   XN: IXMLNode;
begin
   TreeView1.Items.Clear;
{

   try
   begin

   end;
   catch(Exception &e)
   begin
      ShowMessage(e.Message);
   end;
}
   XMLDocument1.LoadFromFile(szFileName);
   iX:=0;
   iR:=0;
   iE:=0;
   iT:=0;
   iA:=0;
   iV:=0;

   if ( Not ( XMLDocument1.IsEmptyDoc ) ) then
   begin
      TN := TreeView1.Items.Add( nil, ExtractFileName( szFileName ) );
      TN.ImageIndex := 0;
      TN.SelectedIndex := 0;
      iX := 1;
      XN := XMLDocument1.DocumentElement;
      XMLTree(TN, XN, 1);
   end;
   TreeView1.FullExpand();

   Label7.Caption := IntToStr(iX);
   Label8.Caption := IntToStr(iR);
   Label9.Caption := IntToStr(iE);
   Label10.Caption := IntToStr(iT);
   Label11.Caption := IntToStr(iA);
   Label12.Caption := IntToStr(iV);

end;

procedure TForm1.XMLTree(TN: TTreeNode; XN: IXMLNode; iIndex: Integer);
var
    TN1, TN2: TTreeNode;
    XN1: IXMLNode;
    XNL: IXMLNodeList;
    i, j: Integer;
begin

   case iIndex of
      0:
      begin
         TN1 := TN;
         //break;
      end;

      1:
      begin
         TN1 := TreeView1.Items.AddChild( TN, XN.NodeName );
         TN1.ImageIndex := 1;
         TN1.SelectedIndex := 1;
         iR := 1;
         //break;
      end;

      2:
      begin
         TN1 := TreeView1.Items.AddChild( TN, XN.NodeName);
         TN1.ImageIndex := 2;
         TN1.SelectedIndex := 2;
         Inc( iE );
         //break
      end;

      3:
      begin
         TN1 := TreeView1.Items.AddChild( TN, XN.NodeValue );
         TN1.ImageIndex := 3;
         TN1.SelectedIndex := 3;
         Inc( iT );
         //return;
         exit;
      end;

      4:
      begin
         TN1 := TreeView1.Items.AddChild( TN, XN.NodeName );
         TN1.ImageIndex := 4;
         TN1.SelectedIndex := 4;
         Inc( iA );
         XMLTree( TN1, XN, 5 );
         //return;
         exit;
      end;

      5:
      begin
         TN1 := TreeView1.Items.AddChild( TN, XN.NodeValue );
         TN1.ImageIndex := 5;
         TN1.SelectedIndex := 5;
         Inc( iV );
         exit;
      end;
   end;

   if ( XN.HasChildNodes ) then
   begin
      ListBox1.Items.Add( IntToStr( XN.ChildNodes.Count ) );
      for i := 0 to XN.ChildNodes.Count - 1 do
      begin
         TN2 := nil;
         XN1 := nil;
         XNL := nil;
         XN1 := XN.ChildNodes.Nodes[i];
         XNL := XN1.GetAttributeNodes;
         if (XNL.Count>0) then
         begin
            TN2 := TreeView1.Items.AddChild(TN1, XN1.NodeName);
            TN2.ImageIndex := 2;
            TN2.SelectedIndex := 2;
            Inc( iE );
            for j := 0 to XNL.Count -1 do
            begin
               XMLTree( TN2, XNL.Nodes[j], 4 );
            end;
            XMLTree( TN2, XN1, 0 );
         end
         else
         begin
            if (XN1.IsTextElement) then
            begin
               TN2 := TreeView1.Items.AddChild( TN1, XN1.NodeName );
               TN2.ImageIndex := 2;
               TN2.SelectedIndex := 2;
               Inc( iE );
               XMLTree( TN2, XN1, 3 );
            end
            else
            begin
               XMLTree( TN1, XN1, 2 );
            end;
         end;
      end;
   end;
end;

end.
